select den,
       tyden,
       pk_roakidno,
       druh_akce,
       predm,
       typ_jed_akce,
       --pozice_od,
       --pozice_do,
       --cas_od_do,
       to_date(to_char(skut_hod_od,'HH24:MI:SS')||' 01.01.1950','HH24:MI:SS DD.MM.RRRR') AS hod_skut_od,
       --skut_hod_od AS hod_skut_od,
       to_date(to_char(skut_hod_do,'HH24:MI:SS')||' 01.01.1950','HH24:MI:SS DD.MM.RRRR') AS hod_skut_do,
       --skut_hod_do AS hod_skut_do,
       fk_typ,
       typ_akce,
       null datum,
       CG.RV_MEANING radek,
       fk_zkr_budovy,
       fk_cislo_mist,
       mistnost,
       fk_prac_zkr,
       fk_zkr_predm,
       fk_rok_varianty,
       ucitel,
       ucitel_pom,
       ucitel_prijmeni,
       fk_ucitidno,
       fk_tyden,
       typ_casoprostoru,
       CG.poradi den_poradi,
       tyden_od,
       tyden_do,
       min(tyden_rozsah) datum_od,
       max(tyden_rozsah) datum_do
  from cg_ref_codes CG, -- pro den v tydnu
(
select
       DECODE(:lang, 'cs', c1.rv_meaning, 'sk', c1.rv_meaning, NVL(c1.english, c1.rv_meaning)) AS den,
       decode(cp.obsadil,'R',DECODE(:lang, 'cs', fn_meaning2(tyden,'TYDEN'), 'sk', fn_meaning2(tyden,'TYDEN'), NVL(fn_meaning_en(tyden,'TYDEN'), fn_meaning2(tyden,'TYDEN'))),DECODE(:lang, 'cs', fn_meaning2('J','TYDEN'), 'sk', fn_meaning2('J','TYDEN'), NVL(fn_meaning_en('J','TYDEN'), fn_meaning2('J','TYDEN')))) tyden,
       case
         when obsadil ='R' then
           CP.roakidno
         when obsadil in ('J','B') then
           cp.JEDAIDNO
         when obsadil ='Z' then
           CP.termidno
         when obsadil='G' then
           g.nateidno
         when obsadil='T' then
           cp.termin_idno
         else
           cp.terroz_idno end as pk_roakidno,
       CP.obsadil druh_akce,
       case
         when obsadil ='R' then
           RA.prac_zkr||'/'||RA.zkr_predm
         when obsadil ='J' then
           JA.POZNAMKA
         when obsadil ='B' then
           JA.PRAC_ZKR||'-'||JA.POZNAMKA
         when obsadil in ('Z') then
           Z.prac_zkr||'/'||Z.zkr_predm
         when obsadil in ('G') then
           fn_get_zkr_natgr(g.nateidno)
         when obsadil='T' then
           T.ADRESA
         else
           T2.ADRESA end as predm,
           JA.typ_jed_akce,
       /*(to_number(to_char(CP.skut_hod_od,'HH24'))-6)*12+round(to_number(to_char(CP.skut_hod_od,'MI'))/5,0) pozice_od,
       (to_number(to_char(CP.skut_hod_do,'HH24'))-6)*12+round(to_number(to_char(CP.skut_hod_do,'MI'))/5,0) pozice_do,*/
       /*to_char(CP.skut_hod_od, 'HH24:MI')||'-'||to_char(CP.skut_hod_do, 'HH24:MI') cas_od_do,*/
       to_date(to_char(CP.skut_hod_od,'HH24:MI'),'HH24:MI') skut_hod_od,
       to_date(to_char(CP.skut_hod_do,'HH24:MI'),'HH24:MI') skut_hod_do,
       decode(cp.obsadil,'R',RA.typakce,'J',JA.typ_jed_akce,'B',JA.typ_jed_akce,'Z','zk','G','gzk','T','prjmr','P','prjmr','ost') fk_typ,
       decode(cp.obsadil,'R',decode(:lang,'cs',fn_meaning2(RA.typakce,'TYP_AKCE'),'sk',fn_meaning2(RA.typakce,'TYP_AKCE'),nvl(fn_meaning_en(RA.typakce,'TYP_AKCE'),fn_meaning2(RA.typakce,'TYP_AKCE'))),'J',decode(:lang,'cs',fn_meaning2(JA.typ_jed_akce,'TYP_JED_AKCE'),'sk',fn_meaning2(JA.typ_jed_akce,'TYP_JED_AKCE'),nvl(fn_meaning_en(JA.typ_jed_akce,'TYP_JED_AKCE'),fn_meaning2(JA.typ_jed_akce,'TYP_JED_AKCE'))),'B',decode(:lang,'cs',fn_meaning2(JA.typ_jed_akce,'TYP_JED_AKCE'),'sk',fn_meaning2(JA.typ_jed_akce,'TYP_JED_AKCE'),nvl(fn_meaning_en(JA.typ_jed_akce,'TYP_JED_AKCE'),fn_meaning2(JA.typ_jed_akce,'TYP_JED_AKCE'))),nvl(decode(:lang,'cs',fn_meaning2(cp.obsadil,'TYP_CASOPROSTORU'),'sk',fn_meaning2(cp.obsadil,'TYP_CASOPROSTORU'),nvl(fn_meaning_en(cp.obsadil,'TYP_CASOPROSTORU'),fn_meaning2(cp.obsadil,'TYP_CASOPROSTORU'))),decode(:lang,'cs','Ostatn\u00ed','sk','Ostatn\u00ed','Other'))) typ_akce,
       CP.datum,
       CP.den radek,
       CP.zkr_budovy as fk_zkr_budovy,
       CP.cislo_mist as fk_cislo_mist,
       CP.zkr_budovy||CP.cislo_mist as mistnost,
       decode(cp.obsadil,'R',RA.PRAC_ZKR ,'Z',z.PRAC_ZKR ,'-') fk_prac_zkr,
       decode(cp.obsadil,'R',RA.ZKR_PREDM ,'Z',z.ZKR_PREDM ,'-') fk_zkr_predm,
       decode(cp.obsadil,'R',RA.ROK_VARIANTY ,'Z',z.ROK_PLATNOSTI ,'G',z.ROK_PLATNOSTI ,CP.ROK_PLATNOSTI) fk_rok_varianty,
       decode(cp.obsadil,'R',fn_get_ucitel(uc_roakce.ucitidno,'JP','A'),'Z',fn_get_ucitel(z.ucitidno,'JP','A'),NULL) ucitel,
       decode(cp.obsadil,'R',fn_get_ucitel(uc_roakce.ucitidno,'PJ','N'),'Z',fn_get_ucitel(z.ucitidno,'PJ','N'),NULL) ucitel_pom,
       decode(cp.obsadil,'R',(select u.prijmeni from ucitele u where u.ucitidno=uc_roakce.ucitidno),'Z',(select u.prijmeni from ucitele u where u.ucitidno=z.ucitidno),NULL) ucitel_prijmeni,
       decode(cp.obsadil,'R',uc_roakce.ucitidno,'Z',z.ucitidno,NULL) fk_ucitidno,
       decode(cp.obsadil,'R',RA.tyden,'J') fk_tyden,
       decode(:lang,'cs',fn_meaning2(CP.obsadil,'TYP_CASOPROSTORU'),'sk',fn_meaning2(CP.obsadil,'TYP_CASOPROSTORU'),nvl(fn_meaning_en(CP.obsadil,'TYP_CASOPROSTORU'),fn_meaning2(CP.obsadil,'TYP_CASOPROSTORU'))) as typ_casoprostoru,
       decode(cp.obsadil,'R',RA.tyden_od,NULL) tyden_od,
       decode(cp.obsadil,'R',RA.tyden_do,NULL) tyden_do,
       CP.datum tyden_rozsah
  from casoprostor cp,
       terminy z,
       grupy_terminu g,
       jedakce JA,
       rozvrh_akce RA,
       pr_terminy t,
       pr_terminy_rozpis p,
       pr_terminy t2,
       cg_ref_codes c1,
          (select 0 priorita, ra2.roakidno, ra2.ucitidno from rozvrh_akce ra2
           union
           select 1 priorita, uc.roakidno, uc.ucitidno from uc_rozvrhove_akce uc) uc_roakce
 where cp.zkr_budovy = upper(:xbud)
   and cp.cislo_mist = :xmist
   and cp.datum between (select min(k1.datum) from kalendar k1 where k1.rok_platnosti = :xrok and k1.typ_rozvrh_dne = :xsem) AND (select max(k2.datum) from kalendar k2 where k2.rok_platnosti = :xrok and k2.typ_rozvrh_dne = :xsem)
   --and to_number(to_char(cp.skut_hod_od,'HH24')) >= 6 -- netiskneme akce pred sestou hodinou ranni
   and (
        (CP.obsadil='R')
       OR (CP.obsadil='J')
       OR (CP.obsadil='B')
       OR (CP.obsadil in ('Z','G'))
       OR (CP.obsadil in ('T','P'))
       )
   and z.termidno(+)=cp.termidno
   AND G.GRTEIDNO(+) = Z.GRTEIDNO
   AND (Z.GRTEIDNO IS NULL OR Z.GRTEIDNO IS NOT NULL AND Z.TERMIDNO =
       (SELECT MIN(TZ2.termidno) FROM terminy TZ2, grupy_terminu GT2 WHERE TZ2.GRTEIDNO = GT2.GRTEIDNO AND GT2.nateidno = G.nateidno))
   and JA.jedaidno(+)=cp.jedaidno
   and ra.roakidno(+)=cp.roakidno
   and t.TERMIN_IDNO(+)=cp.termin_idno
   and p.terroz_idno(+)=cp.terroz_idno
   and p.termin_idno=t2.termin_idno(+)
--   and z.platnost(+) <> 'N'
   AND trunc(Cp.skut_hod_od) != Cp.skut_hod_od
       AND  cp.den = c1.rv_low_value
    AND  c1.rv_domain= 'DEN'
   and  uc_roakce.roakidno(+) = ra.roakidno
 order by cp.datum, CP.zkr_budovy, CP.cislo_mist,
       (to_number(to_char(CP.skut_hod_od,'HH24'))-6)*12+round(to_number(to_char(CP.skut_hod_od,'MI'))/5,0),
       (to_number(to_char(CP.skut_hod_do,'HH24'))-6)*12+round(to_number(to_char(CP.skut_hod_do,'MI'))/5,0),
       ra.roakidno, uc_roakce.priorita
) X
 WHERE CG.rv_domain = 'DEN'
   and CG.rv_abbreviation = X.radek
 GROUP BY
       den,
       tyden,
       pk_roakidno,
       druh_akce,
       predm,
       typ_jed_akce,
       --pozice_od,
       --pozice_do,
       --cas_od_do,
       skut_hod_od,
       skut_hod_do,
       fk_typ,
       typ_akce,
       CG.RV_MEANING,
       fk_zkr_budovy,
       fk_cislo_mist,
       mistnost,
       fk_prac_zkr,
       fk_zkr_predm,
       fk_rok_varianty,
       CG.poradi,
       ucitel,
       ucitel_pom,
       ucitel_prijmeni,
       fk_ucitidno,
       fk_tyden,
       typ_casoprostoru,
       CG.poradi,
       tyden_od,
       tyden_do
 order by CG.poradi,to_number(to_char(skut_hod_od,'HH24MI'))
