select
	dp.os_cislo,
	o.prijmeni,
	o.jmeno,
	dp.prac_zkr,
	dp.dat_zadani,
	dp.plan_dat_odevzdani,
	fn_tex_text(dp.tema_hlavni) nazev,
	DECODE(:lang, 'cs', c1.rv_meaning, 'sk', c1.rv_meaning, NVL(c1.english, c1.rv_meaning)) AS vztah_k_dp,
	dp.adipidno,
	sp.typ
from
	abn_diplomove_prace dp,
	studenti s,
	osoby o,
	abn_dp_osoby dpo,
	studijni_programy SP,
	cg_ref_codes c1
where
	dp.os_cislo=s.os_cislo
	and   s.osobidno=o.osobidno
	and   dp.adipidno=dpo.adipidno
	and   dpo.ucitidno=:ucitidno
	and   tisknout='A'
	and s.stpridno = sp.stpridno
	and c1.RV_DOMAIN = 'TYP_OSOBY_DP'
	and c1.RV_LOW_VALUE = dpo.TYP_OSOBY
@IF(0)	and   to_char(dp.dat_zadani,'YYYY') = (select rok_platnosti from kalendar where  datum = trunc(sysdate))
order by dp.dat_zadani desc