(
select kx.datum datum,
       'AKROK_Z' akce,
       'Začátek ak. roku' popis
  from kalendar kx
 where kx.rok_platnosti = :rokPlatnosti
   and kx.datum = ( select MIN(datum) datum
                      from kalendar
                     where rok_platnosti = :rokPlatnosti
               )
)
union
(
select k2.datum datum,
       /*k1.typ_rozvrh_dne||'->'||*/k2.typ_rozvrh_dne akce,
       'Začíná: '||cg1.RV_MEANING popis
  from kalendar k1,
       kalendar k2,
       cg_ref_codes cg1
 where k1.rok_platnosti = :rokPlatnosti
   and k2.rok_platnosti = :rokPlatnosti
   and k1.datum = k2.datum-1
   and k1.typ_rozvrh_dne <> k2.typ_rozvrh_dne
   and cg1.RV_DOMAIN = 'TYP_ROZVRH_DNE'
   and cg1.rv_low_value = k2.typ_rozvrh_dne
)
union
(
select ky.datum datum,
       'AKROK_K' akce,
       'Konec ak. roku' popis
  from kalendar ky
 where ky.rok_platnosti = :rokPlatnosti
   and ky.datum = ( select MAX(datum) datum
                      from kalendar
                     where rok_platnosti = :rokPlatnosti
               )
)
order by datum
